' ------------------------------------------------------------------
' ASMTimer
' Clock cycles code timer
'
' Free code by Marco Pontello - 2004
' ------------------------------------------------------------------
 #DEBUG ERROR OFF
 #TOOLS OFF
 #INCLUDE "Win32API.inc"
 #INCLUDE "X_AU.inc"

 FUNCTION A_AY_T(BYVAL a AS LONG,BYVAL b AS LONG) AS DWORD
REGISTER e AS DWORD,f AS DWORD
A_DIV(f,a,b)
A_INC(f)
!MOV EAX,f
!MUL b
!MOV function,eax
END FUNCTION

FUNCTION A_AY_D(BYVAL a AS LONG,BYVAL b AS LONG) AS DWORD
FUNCTION = (a\b+1)*b
END FUNCTION
  SUB TestfuncD()
  REGISTER R01  AS LONG
   R01=A_AY_D(100,90)
END SUB

SUB TestfuncT()
REGISTER R01 AS LONG
R01=A_AY_T(100,90)
END SUB


' Macros for using the Pentium RDTSC opcode
' (ReaD Time Stamp counter (clock cycles)
' in EDX,EAX registers)
MACRO CCC_Start
! DB &hF
! DB &h31
! MOV MHiS, EDX
! MOV MLoS, EAX
END MACRO
MACRO CCC_End
! DB &hF
! DB &h31
! MOV MHiE, EDX
! MOV MLoE, EAX
END MACRO

FUNCTION PBMAIN
LOCAL RES,REA AS QUAD
DIM MHiS AS DWORD
DIM MLoS AS DWORD
DIM MHiE AS DWORD
DIM MLoE AS DWORD
DIM T1 AS QUAD, T2 AS QUAD, Diff AS QUAD, MinDiff AS QUAD
REGISTER R01 AS LONG
DIM OverHeadCycles AS LONG
' ----------------
' Any needed var declarations should go here!
' Repeat the code enough time to get reliable results
FOR R01 = 1 TO 1000000

CCC_Start
' -----------------------------------------------
     !NOP
     !NOP
     !NOP
TestfuncT()

' -----------------------------------------------
CCC_End
Res = MHiS
SHIFT LEFT Res, 32
Res = Res + MLoS
t1 = Res
Res = MHiE
SHIFT LEFT Res, 32
Res = Res + MLoE
t2 = Res
IF t2 > t1 THEN
Diff = t2 - t1
IF MinDiff = 0 THEN
MinDiff = Diff
ELSE
IF Diff < MinDiff THEN
MinDiff = Diff
END IF
END IF
END IF
IF R01=1 THEN X_AU "First Result:"+STR$(Diff-8)
IF R01=2 THEN X_AU "Second Result:"+STR$(Diff-8)
NEXT R01
' Simply time a null block to get the correct overhead for a
' given CPU/system
OverHeadCycles = 11-4
X_AU "Statistical Result:"+STR$(MinDiff - OverHeadCycles)
X_AU "-----------------------------------------"
' This is just to check that the code do what is supposed to do...
X_AU Text$
X_AU "-----------------------------------------"
X_AU "-- Finished!"
? "!"
END FUNCTION
